import _regeneratorRuntime from "@babel/runtime/regenerator";

var _marked =
/*#__PURE__*/
_regeneratorRuntime.mark(fetchCreateCartData),
    _marked2 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchCreateCartData),
    _marked3 =
/*#__PURE__*/
_regeneratorRuntime.mark(updateCartData),
    _marked4 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchUpdateCartData);

import { put, call, takeEvery } from "redux-saga/effects";
import ACTION_TYPES from "../const/ACTION_TYPES";
import * as CartApi from "../api/cartApi";
export function fetchCreateCartData(action) {
  var response;
  return _regeneratorRuntime.wrap(function fetchCreateCartData$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.prev = 0;
          _context.next = 3;
          return call(CartApi.createCart, action.data);

        case 3:
          response = _context.sent;
          _context.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_CART_DATA,
            data: response.data
          });

        case 6:
          _context.next = 13;
          break;

        case 8:
          _context.prev = 8;
          _context.t0 = _context["catch"](0);
          console.error("Create Cart request failed");
          _context.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_CART_ERROR,
            error: _context.t0
          });

        case 13:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, null, [[0, 8]]);
}
export function watchCreateCartData() {
  return _regeneratorRuntime.wrap(function watchCreateCartData$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.CREAT_N_FETCH_CART_DATA, fetchCreateCartData);

        case 2:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2);
}
export function updateCartData(action) {
  var response;
  return _regeneratorRuntime.wrap(function updateCartData$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          _context3.prev = 0;
          _context3.next = 3;
          return call(CartApi.updateCart, action.data);

        case 3:
          response = _context3.sent;
          _context3.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_UPDATE_CART_DATA,
            data: response.data
          });

        case 6:
          _context3.next = 13;
          break;

        case 8:
          _context3.prev = 8;
          _context3.t0 = _context3["catch"](0);
          console.error("update Cart request failed");
          _context3.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.UPDATE_CART_DATA_ERROR,
            error: _context3.t0
          });

        case 13:
        case "end":
          return _context3.stop();
      }
    }
  }, _marked3, null, [[0, 8]]);
}
export function watchUpdateCartData() {
  return _regeneratorRuntime.wrap(function watchUpdateCartData$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          _context4.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.UPDATE_CART_DATA, updateCartData);

        case 2:
        case "end":
          return _context4.stop();
      }
    }
  }, _marked4);
}